//le maxi de minis.mq4
//Evgeny I. SHCHERBINA
#property copyright "Evgeny I. SHCHERBINA"

extern double lot = 0.1;
double maxi = 0, mini = 0;
int timer1 = 120, ts = 0, ticket, t_modify, g_ticket = 0;
string object;

int init(){
  if(OrdersTotal() == 0){
    maxi = 0; 
    mini = 0;
    ts = 0; 
    ObjectDelete("arrow1");
    ObjectDelete("arrow2");
  }else{
    OrderSelect(0,SELECT_BY_POS);
    if(OrderType() == OP_SELL && (OrderStopLoss() <= OrderOpenPrice())){
      ts = 1;
    }else if(OrderType() == OP_BUY && (OrderStopLoss() >= OrderOpenPrice())){
      ts = 1;
    }
  }
  //timer1_ticking();
}

int start(){
  if(OrdersTotal() == 0){
    if(g_ticket > 0){
      mini = 0;
      maxi = 0;
      ts = 0;
      g_ticket = 0;
      ObjectDelete("arrow1");
      ObjectDelete("arrow2");
    }
    find_maxi(); 
    find_mini();
  }
  if(OrdersTotal() > 0){
    OrderSelect(0,SELECT_BY_POS);
    g_ticket = OrderTicket();
    if(OrderType() == OP_SELL && (OrderOpenPrice()-50*Point) >= Bid && ts == 0){
      t_modify = OrderModify(OrderTicket(),OrderOpenPrice(),Bid+50*Point,OrderTakeProfit(),0,Red);
      ts = 1;
    }else if(OrderType() == OP_SELL && (OrderStopLoss()-100*Point) >= Bid && ts == 1){
      t_modify = OrderModify(OrderTicket(),OrderOpenPrice(),Bid+100*Point,OrderTakeProfit(),0,Red);
    }
    if(OrderType() == OP_BUY && (OrderOpenPrice()+50*Point) <= Ask && ts == 0){
      t_modify = OrderModify(OrderTicket(),OrderOpenPrice(),Ask-50*Point,OrderTakeProfit(),0,Red);
      ts = 1;
    }else if(OrderType() == OP_BUY && (OrderStopLoss()+100*Point) <= Ask && ts == 1){
      t_modify = OrderModify(OrderTicket(),OrderOpenPrice(),Ask-100*Point,OrderTakeProfit(),0,Red);
    }
  }
  return;
}

/*int timer1_ticking(){
  while(timer1 >= 0){
    timer1--;
    object = " : " + timer1 + " .";
    ObjectSetText("Obj",object,12,"Times New Roman",Aqua);
    ObjectCreate("Obj",OBJ_LABEL, 0, 0, 0);
    ObjectSet("Obj", OBJPROP_XDISTANCE, 5);
    ObjectSet("Obj",OBJPROP_YDISTANCE,20);
    Sleep(1000);
  }
}*/

int find_maxi(){
  int i;
  double oc1, oc2, oc3, oc4, oc5, oc6, oc7;
  for(i=0; i>=0; i++){
    if(Close[i] > Open[i]){oc4 = Close[i];}
    else{oc4 = Open[i];}
    if(oc4 > Bid){
      if(Close[i-3] > Open[i-3]){oc1 = Close[i-3];}
      else{oc1 = Open[i-3];}
      if(Close[i-2] > Open[i-2]){oc2 = Close[i-2];}
      else{oc2 = Open[i-2];}
      if(Close[i-1] > Open[i-1]){oc3 = Close[i-1];}
      else{oc3 = Open[i-1];}
      if(Close[i+1] > Open[i+1]){oc5 = Close[i+1];}
      else{oc5 = Open[i+1];}
      if(Close[i+2] > Open[i+2]){oc6 = Close[i+2];}
      else{oc6 = Open[i+2];}
      if(Close[i+3] > Open[i+3]){oc7 = Close[i+3];}
      else{oc7 = Open[i+3];}
      if(oc1 <= oc4 && oc2 <= oc4 && oc3 <= oc4 && oc5 <= oc4 && oc6 <= oc4 && oc7 <= oc4){
        if(maxi == 0){ObjectDelete("arrow1"); maxi = oc4;}
        ObjectCreate("arrow1",OBJ_ARROW, 0, Time[i], High[i]+0.001);
        ObjectSet("arrow1",OBJPROP_ARROWCODE,218);
        ObjectSet("arrow1",OBJPROP_COLOR,Aqua);
        break;
      }
    }
    if(maxi == Bid){open_order(1);}
  }
}

int find_mini(){
  int i;
  double oc1, oc2, oc3, oc4, oc5, oc6, oc7;
  for(i=0; i>=0; i++){
    if(Close[i] < Open[i]){oc4 = Close[i];}
    else{oc4 = Open[i];}
    if(oc4 < Bid){
      if(Close[i-3] < Open[i-3]){oc1 = Close[i-3];}
      else{oc1 = Open[i-3];}
      if(Close[i-2] < Open[i-2]){oc2 = Close[i-2];}
      else{oc2 = Open[i-2];}
      if(Close[i-1] < Open[i-1]){oc3 = Close[i-1];}
      else{oc3 = Open[i-1];}
      if(Close[i+1] < Open[i+1]){oc5 = Close[i+1];}
      else{oc5 = Open[i+1];}
      if(Close[i+2] < Open[i+2]){oc6 = Close[i+2];}
      else{oc6 = Open[i+2];}
      if(Close[i+3] < Open[i+3]){oc7 = Close[i+3];}
      else{oc7 = Open[i+3];}
      if(oc1 >= oc4 && oc2 >= oc4 && oc3 >= oc4 && oc5 >= oc4 && oc6 >= oc4 && oc7 >= oc4){
        if(mini == 0){ObjectDelete("arrow2"); mini = oc4;}
        ObjectCreate("arrow2",OBJ_ARROW, 0, Time[i], Low[i]-0.0005);
        ObjectSet("arrow2",OBJPROP_ARROWCODE,217);
        ObjectSet("arrow2",OBJPROP_COLOR,Aqua);
        break;
      }
    }
    if(mini == Bid){open_order(2);}
  }
}

int open_order(int type){
  if(OrdersTotal() == 0){
    if(type == 1){
      ticket = OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+100*Point,mini,"sh_order",356111515938,0,Green);
    }else if(type == 2){
      ticket = OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-100*Point,maxi,"sh_order",356111515938,0,Green);
    }
  }
}